*(WALKLIST.CMD 
  scroll through a list of customers )
SET MESSAGE OFF
SET ERROR MESSAGE OFF
DROP CURSOR C1
CLS

DECLARE C1 scroll CURSOR FOR +
  SELECT CustId, LastName, Company FROM Customer +
   WHERE calldate = .#DATE ORDER BY Company

OPEN C1
FETCH FIRST FROM C1 INTO +
  VCustId ICustId, VLastname ILastname, +
  VCompany ICompany
WHILE SQLCODE <> 100 THEN

  EDIT USING cust WHERE CustId = .VCustId
  CHOOSE VAction FROM WALKLIST.MNU AT 10 51 FOOT
  IF VAction = '[ESC]' THEN
    RETURN
  ENDIF

  SWITCH (.VAction)

  CASE 'Next Customer'
    FETCH NEXT FROM C1 INTO +
     VCustId ICustId, VLastname ILastname, +
     VCompany ICompany

    IF SQLCODE = 100 THEN
      FETCH LAST FROM C1 INTO +
       VCustId ICustId, VLastname ILastname, +
       VCompany ICompany
    ENDIF
    BREAK

  CASE 'Previous Customer'
    FETCH PRIOR FROM C1 INTO +
     VCustId ICustId, VLastname ILastname, +
     VCompany ICompany

    IF SQLCODE = 100 THEN
      FETCH FIRST FROM C1 INTO +
       VCustId ICustId, VLastname ILastname, +
       VCompany ICompany
    ENDIF
    BREAK

  CASE 'Jump Forward "n"'
    DIALOG 'How many to jump forward' VNum=4 VEndKey 1
    SET VAR VPlus = (INT(.VNum))
    FETCH RELATIVE .vplus FROM C1 INTO +
     VCustId ICustId, VLastname ILastname, +
     VCompany ICompany

    IF SQLCODE = 100 THEN
      FETCH LAST FROM C1 INTO +
       VCustId ICustId, VLastname ILastname, +
       VCompany ICompany
    ENDIF
    BREAK

  CASE 'Jump Backward "n"'
    DIALOG 'How many to jump backward' VNum=4 VEndKey 1
    SET VAR VMinus = (INT(.VNum) * -1)
    FETCH RELATIVE .vminus FROM C1 INTO +
     VCustId ICustId, VLastname ILastname, +
     VCompany ICompany

    IF SQLCODE = 100 THEN
      FETCH FIRST FROM C1 INTO +
       VCustId ICustId, VLastname ILastname, +
       VCompany ICompany
    ENDIF
    BREAK

  CASE 'Last Customer'
    FETCH LAST FROM C1 INTO +
     VCustId ICustId, VLastname ILastname, +
     VCompany ICompany
    BREAK

  CASE 'First Customer'
    FETCH FIRST FROM C1 INTO +
     VCustId ICustId, VLastname ILastname, +
     VCompany ICompany
    BREAK

  CASE 'Search by Lastname'
    SET VAR vsearch = NULL
    DIALOG 'Enter the last name to find' +
      VSearch VEndKey 1 at 12
    IF VEndKey = '[Esc]' THEN
      BREAK
    ENDIF

    WHILE #PI <> 0.0 THEN
      FETCH NEXT FROM c1 INTO +
       VCustID ICustId, VLastname ILastname, +
       VCompany ICompany
      IF VLastname CONT .VSearch THEN
        BREAK
      ENDIF

      IF SQLCODE = 100 THEN
        DIALOG +
         'No match found. Continue search from beginning?' +
         VResp VEndKey YES
        IF VEndKey = '[Esc]' THEN
          BREAK
        ENDIF
        IF VResp = 'YES' THEN 
          FETCH FIRST FROM c1 INTO +
           VCustID ICustId, VLastname ILastname, +
           VCompany ICompany
          IF VLastname CONT .VSearch THEN
            BREAK
          ENDIF
        ELSE
          FETCH LAST FROM c1 INTO +
           VCustID ICustId, VLastname ILastname, +
           VCompany ICompany
          BREAK
        ENDIF
      ENDIF
    ENDWHILE
    BREAK

  CASE 'Search by Company'
    SET VAR VSearch = NULL
    DIALOG 'Enter the company to find' +
     VSearch VEndKey 1 at 12
    IF VEndKey = '[Esc]' THEN
      BREAK
    ENDIF

    WHILE #PI <> 0.0 THEN
      FETCH NEXT FROM c1 INTO +
       VCustID ICustId, VLastname ILastname, +
       VCompany ICompany
      IF VCompany CONT .VSearch THEN
        BREAK
      ENDIF

      IF SQLCODE = 100 THEN
        DIALOG +
         'No match found. Continue search from beginning?' +
         VResp VEndKey YES
        IF VEndKey = '[Esc]' THEN
          BREAK
        ENDIF
        IF VResp = 'YES' THEN 
          FETCH FIRST FROM c1 INTO +
           VCustID ICustId, VLastname ILastname, +
           VCompany ICompany
          IF VCompany CONT .VSearch THEN
            BREAK
          ENDIF
        ELSE
          FETCH LAST FROM c1 INTO +
           VCustID ICustId, VLastname ILastname, +
           VCompany ICompany
          BREAK
        ENDIF
      ENDIF
    ENDWHILE
    BREAK
  ENDSW
ENDWHILE
DROP CURSOR C1
RETURN
 

